package com.maroontress.sanctuary;

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ΥåȤǤ

   ᥽åɤޤϥޥΤ٤Ƥΰݻޤ
*/
public abstract class Parameters {

    /** Υꥹ */
    private LinkedList<Parameter> v;

    /** ĹǤ뤫ɤ */
    private boolean isVarible;

    /**
       ΥåȤޤ

       @param g 롼
       @param nodes ΥΡɥꥹ
       @param variableNodes ĹΥΡɥꥹ
    */
    protected Parameters(final Group g, final NodeList nodes,
			 final NodeList variableNodes) {
	v = new LinkedList<Parameter>();
	isVarible = false;

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    v.add(createParameter(g, elem));
	}
	if (variableNodes.getLength() == 0) {
	    return;
	}
	isVarible = true;
	v.add(new VariableParameter());
    }

    /**
       ѥ᡼ޤ

       @param k 
       @param param ѥ᡼
    */
    public void insert(final int k, final Parameter param) {
        v.add(k, param);
    }

    /**
       ޤ

       @param g 롼
       @param elem 
       @return 
    */
    protected abstract Parameter createParameter(Group g, Element elem);

    /**
       ٤ƤΰɽHTMLʸޤ

       @param g °륰롼
       @return ٤ƤΰɽHTMLʸ
    */
    public String getHTML(final Group g) {
	String s = "", token = "";
	for (Parameter m : v) {
	    s += token + m.getHTML(g);
	    token = ", ";
	}
	return s;
    }

    /**
       ꤷֹΰޤ

       @param k ֹ
       @return 
    */
    public Parameter getParameter(final int k) {
	if (k >= v.size()) {
	    return null;
	}
	return v.get(k);
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == ((isVarible) ? 1 : 0)) {
	    return;
	}
	wr.println(""
+ "<dl>Parameters:<dd>");
	for (Parameter m : v) {
	    m.printDetail(wr);
	}
	wr.println(""
+ "</dd></dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == ((isVarible) ? 1 : 0)) {
	    return;
	}
	wr.println("\\Sparameter");
	wr.println("\\begin{Sindentation}{\\Sindentlength}{0pt}");
	wr.println("\\begin{description}");
	for (Parameter m : v) {
	    m.printTexDetail(wr);
	}
	wr.println("\\end{description}");
	wr.println("\\end{Sindentation}");
    }
}
